## openscap 1.3.9+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8...3.19)

# Inspired and referenced from https://blog.kitware.com/cmake-and-the-default-build-type
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "Setting build type to 'Release' as none was specified.")
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
		"MinSizeRel" "RelWithDebInfo")
endif()

project("openscap")
set(OPENSCAP_VERSION_MAJOR "1")
set(OPENSCAP_VERSION_MINOR "3")
set(OPENSCAP_VERSION_PATCH "9")

if(OPENSCAP_VERSION_SUFFIX)
	set(OPENSCAP_VERSION "${OPENSCAP_VERSION_MAJOR}.${OPENSCAP_VERSION_MINOR}.${OPENSCAP_VERSION_PATCH}_${OPENSCAP_VERSION_SUFFIX}")
else()
	set(OPENSCAP_VERSION "${OPENSCAP_VERSION_MAJOR}.${OPENSCAP_VERSION_MINOR}.${OPENSCAP_VERSION_PATCH}")
endif()

# libtool versioning
# See http://sources.redhat.com/autobook/autobook/autobook_91.html#SEC91 for details

## increment if the interface has additions, changes, removals.
set(LT_CURRENT 31)

## increment any time the source changes; set 0 to if you increment CURRENT
set(LT_REVISION 1)

## increment if any interfaces have been added; set to 0
## if any interfaces have been changed or removed. removal has
## precedence over adding, so set to 0 if both happened.
set(LT_AGE 6)

math(EXPR LT_CURRENT_MINUS_AGE "${LT_CURRENT} - ${LT_AGE}")

set(SONAME ${LT_CURRENT_MINUS_AGE}.${LT_AGE}.${LT_REVISION})
set(SOVERSION ${LT_CURRENT_MINUS_AGE})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

message(STATUS "OpenSCAP ${OPENSCAP_VERSION}")
message(STATUS "(see ${CMAKE_SOURCE_DIR}/docs/developer/developer.adoc for build instructions)")
message(STATUS " ")

# Strictly speaking in-source will work but will be very messy, let's
# discourage our users from using them
if ("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
	message(FATAL_ERROR "In-source builds are not supported! Please use out of source builds:\n"
		"$ cd openscap\n"
		"$ rm CMakeCache.txt\n"
		"$ cd build\n"
		"$ cmake ../\n"
		"$ make -j4"
		)
endif()

# In Microsoft Visual Studio, store built binaries to a single directory.
# We need to build all the binaries in a single directory on Windows, because
# vcpkg tool fails to fetch dependent DLLs (libxml, libcurl, etc.) if
# oscap.exe is build to a different directory than openscap.dll.
# See the discussion in https://github.com/Microsoft/vcpkg/issues/1002
if(MSVC)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
	set(CMAKE_PDB_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
	set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endif()

# ---------- INCLUDES CMAKE MODULES

include(GNUInstallDirs)
include(FindPkgConfig)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckCSourceCompiles)
include(CMakeDependentOption)

# ---------- DEPENDENCIES

find_package(ACL)
if(ACL_FOUND)
	check_library_exists("${ACL_LIBRARY}" acl_extended_file "" HAVE_ACL_EXTENDED_FILE)
	check_include_file(acl/libacl.h HAVE_ACL_LIBACL_H)
	check_include_file(sys/acl.h HAVE_SYS_ACL_H)
endif()

find_package(AptPkg)

find_package(Blkid)
if(BLKID_FOUND)
	check_library_exists("${BLKID_LIBRARY}" blkid_get_tag_value "" HAVE_BLKID_GET_TAG_VALUE)
endif()

find_package(Cap)
if(CAP_FOUND)
	check_library_exists("${CAP_LIBRARIES}" cap_get_pid "" HAVE_CAP_GET_PID)
endif()

find_package(CURL)
find_package(DBUS)
find_package(Doxygen)
find_package(GConf)
find_package(Ldap)
find_package(OpenDbx)
if(WITH_PCRE2)
	find_package(PCRE2 REQUIRED)
else()
	find_package(PCRE REQUIRED)
endif()
find_package(PerlLibs)
find_package(Popt)
find_package(Systemd)

find_package(Procps)
if(PROCPS_FOUND)
	check_library_exists("${PROCPS_LIBRARY}" dev_to_tty "" HAVE_DEV_TO_TTY)
	check_include_file(proc/devname.h HAVE_PROC_DEVNAME_H)
endif()

# According to CMake documentation:
# https://cmake.org/cmake/help/latest/module/FindPythonInterp.html
# If calling both find_package(PythonInterp) and find_package(PythonLibs),
# call find_package(PythonInterp) first to get the currently active Python
# version by default with a consistent version of PYTHON_LIBRARIES.
find_package(PythonInterp 3)
find_package(PythonLibs 3)

set(PREFERRED_PYTHON_PATH "${PYTHON_EXECUTABLE}" CACHE PATH "Path to preferred Python")
set(PYTHON3_PATH "${PYTHON_EXECUTABLE}" CACHE PATH "Path to Python3")

find_package(RPM)
if(RPM_FOUND)
	check_library_exists("${RPM_LIBRARY}" rpmReadConfigFiles "" HAVE_RPMREADCONFIGFILES)
	check_library_exists("${RPM_LIBRARY}" headerFormat "" HAVE_HEADERFORMAT)
	check_library_exists("${RPMIO_LIBRARY}" rpmFreeCrypto "" HAVE_RPMFREECRYPTO)
	check_library_exists("${RPM_LIBRARY}" rpmFreeFilesystems "" HAVE_RPMFREEFILESYSTEMS)
	check_library_exists("${RPM_LIBRARY}" rpmVerifyFile "" HAVE_RPMVERIFYFILE)
	set(HAVE_RPMVERCMP 1)
endif()

find_package(SELinux)
find_package(SWIG)
find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)
find_package(XMLSEC REQUIRED)
if (APPLE)
	set(OPENSSL_ROOT_DIR "/usr/local/opt/openssl/")
endif()
find_package(OpenSSL REQUIRED)
add_definitions(${XMLSEC_DEFINITIONS})
if (WIN32)
	add_compile_definitions("XMLSEC_CRYPTO_OPENSSL")
endif()
find_package(BZip2)

# PThread
if (WIN32)
	find_package(ZLIB REQUIRED)
endif()

if (WIN32 AND NOT MINGW)
	find_package(pthread CONFIG REQUIRED)
	set(CMAKE_THREAD_LIBS_INIT ${PThreads4W_LIBRARY})
else()
	find_package(Threads REQUIRED)
endif()
set(CMAKE_THREAD_PREFER_PTHREAD)
set(THREADS_PREFER_PTHREAD_FLAG)
set(THREADS_USE_PTHREADS_WIN32 TRUE)
check_library_exists(pthread pthread_timedjoin_np "" HAVE_PTHREAD_TIMEDJOIN_NP)
check_library_exists(pthread pthread_setname_np "" HAVE_PTHREAD_SETNAME_NP)
check_library_exists(pthread pthread_getname_np "" HAVE_PTHREAD_GETNAME_NP)

# WITH_CRYPTO
set(WITH_CRYPTO "gcrypt" CACHE STRING "gcrypt|nss3")
if(NOT (${WITH_CRYPTO} EQUAL "nss3"))
	# gcrypt
	find_package(GCrypt)
else()
	# nss3
	find_package(NSS)
endif()
if(GCRYPT_FOUND OR NSS_FOUND)
	set(CRYPTO_FOUND TRUE)
endif()

find_package(Libyaml)
if(EXISTS ${CMAKE_SOURCE_DIR}/yaml-filter/CMakeLists.txt)
	message(STATUS "yaml-filter was found")
	set(YAML_FILTER_FOUND TRUE)
else()
	message(STATUS "yaml-filter was not found")
	set(YAML_FILTER_FOUND FALSE)
endif()

if(PCRE2_FOUND)
	set(HAVE_PCRE2 1)
	message("-- Using PCRE2")
elseif(PCRE_FOUND)
	message("-- Using PCRE")
endif()

check_library_exists(rt clock_gettime "" HAVE_CLOCK_GETTIME)
check_function_exists(posix_memalign HAVE_POSIX_MEMALIGN)
check_function_exists(memalign HAVE_MEMALIGN)
check_function_exists(fts_open HAVE_FTS_OPEN)
check_function_exists(strsep HAVE_STRSEP)
check_function_exists(strptime HAVE_STRPTIME)

check_include_file(syslog.h HAVE_SYSLOG_H)
check_include_file(stdio_ext.h HAVE_STDIO_EXT_H)
check_include_file(shadow.h HAVE_SHADOW_H)
check_include_file(sys/systeminfo.h HAVE_SYS_SYSTEMINFO_H)
check_include_file(getopt.h HAVE_GETOPT_H)
check_include_file(sys/mman.h HAVE_MMAN_H)
check_include_file(sys/uio.h HAVE_UIO_H)
check_include_file(sys/xattr.h HAVE_SYS_XATTR_H)
check_include_file(attr/xattr.h HAVE_ATTR_XATTR_H)
check_include_files("sys/types.h;sys/extattr.h" HAVE_SYS_EXTATTR_H)

# HAVE_ATOMIC_BUILTINS
check_c_source_compiles("#include <stdint.h>\nint main() {uint16_t foovar=0; uint16_t old=1; uint16_t new=2;__sync_bool_compare_and_swap(&foovar,old,new); return __sync_fetch_and_add(&foovar, 1); __sync_fetch_and_add(&foovar, 1);}" HAVE_ATOMIC_BUILTINS)
if(NOT HAVE_ATOMIC_BUILTINS)
	message(WARNING "!!! Compiler does not support atomic builtins. Atomic operation will be emulated using mutex-based locking. !!!")
endif()

mark_as_advanced(ENV_PRESENT VALGRIND_PRESENT)
find_program(ENV_PRESENT env)
find_program(VALGRIND_PRESENT valgrind)
find_program(ASCIIDOC_EXECUTABLE asciidoc)
find_program(SED_EXECUTABLE sed)
find_program(GIT_EXECUTABLE git)

# ---------- CORE FEATURE SWITCHES
if(WIN32 OR APPLE)
	option(ENABLE_SCE "enables Script Check Engine - an alternative checking engine that lets you use executables instead of OVAL for checks" OFF)
else()
	option(ENABLE_SCE "enables Script Check Engine - an alternative checking engine that lets you use executables instead of OVAL for checks" ON)
endif()

# ---------- OVAL FEATURE SWITCHES

option(ENABLE_PROBES "build OVAL probes - each probe implements an OVAL test" TRUE)
set(SEAP_MSGID_BITS 32 CACHE STRING "Size of SEAP_msgid_t in bits [32|64]")
cmake_dependent_option(ENABLE_PROBES_INDEPENDENT "build OVAL probes for independent (cross platform) OVAL tests" ON "ENABLE_PROBES" OFF)
# On some platforms (Windows..) UNIX ends up being empty instead of "false"
set(IS_UNIX FALSE)
if (UNIX)
    set(IS_UNIX TRUE)
endif()
cmake_dependent_option(ENABLE_PROBES_UNIX "build OVAL probes for the UNIX OVAL tests" ${IS_UNIX} "ENABLE_PROBES" OFF)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "Linux" IS_LINUX)
cmake_dependent_option(ENABLE_PROBES_LINUX "build OVAL probes for the Linux OVAL tests" ${IS_LINUX} "ENABLE_PROBES" OFF)
string(COMPARE EQUAL ${CMAKE_SYSTEM_NAME} "Solaris" IS_SOLARIS)
cmake_dependent_option(ENABLE_PROBES_SOLARIS "build OVAL probes for the Solaris OVAL tests" ${IS_SOLARIS} "ENABLE_PROBES" OFF)
set(IS_WIN32 FALSE)
if (WIN32)
    set(IS_WIN32 TRUE)
endif()
cmake_dependent_option(ENABLE_PROBES_WINDOWS "build OVAL probes for the Windows OVAL tests" ${IS_WIN32} "ENABLE_PROBES" OFF)

option(OPENSCAP_ENABLE_SHA1 "Enable using the SHA-1 algorithm" ON)
option(OPENSCAP_ENABLE_MD5 "Enable using the MD5 algorithm" ON)

# INDEPENDENT PROBES
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_ENVIRONMENTVARIABLE "Independent environmentvariable probe" ON "ENABLE_PROBES_INDEPENDENT" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_ENVIRONMENTVARIABLE58 "Independent environmentvariable58 probe" ON "ENABLE_PROBES_INDEPENDENT; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_FAMILY "Independent family probe" ON "ENABLE_PROBES_INDEPENDENT" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_FILEHASH "Independent filehash probe" ON "ENABLE_PROBES_INDEPENDENT; CRYPTO_FOUND; OPENSCAP_ENABLE_SHA1; OPENSCAP_ENABLE_MD5; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_FILEHASH58 "Independent filehash58 probe" ON "ENABLE_PROBES_INDEPENDENT; CRYPTO_FOUND; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_SQL "Independent sql probe" ON "ENABLE_PROBES_INDEPENDENT; OPENDBX_FOUND; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_SQL57 "Independent sql57 probe" ON "ENABLE_PROBES_INDEPENDENT; OPENDBX_FOUND; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_SYSTEM_INFO "Independent system info probe" ON "ENABLE_PROBES_INDEPENDENT" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_TEXTFILECONTENT "Independent textfilecontent probe" ON "ENABLE_PROBES_INDEPENDENT; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_TEXTFILECONTENT54 "Independent textfilecontent54 probe" ON "ENABLE_PROBES_INDEPENDENT; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_VARIABLE "Independent variable probe" ON "ENABLE_PROBES_INDEPENDENT" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_XMLFILECONTENT "Independent xmlfilecontent probe" ON "ENABLE_PROBES_INDEPENDENT; NOT WIN32" OFF)
cmake_dependent_option(OPENSCAP_PROBE_INDEPENDENT_YAMLFILECONTENT "Independent yamlfilecontent probe" ON "ENABLE_PROBES_INDEPENDENT; LIBYAML_FOUND; YAML_FILTER_FOUND; NOT WIN32" OFF)

# UNIX PROBES
cmake_dependent_option(OPENSCAP_PROBE_UNIX_DNSCACHE "Unix dnscache probe" ON "ENABLE_PROBES_UNIX" OFF)
cmake_dependent_option(OPENSCAP_PROBE_UNIX_FILE "Unix file probe" ON "ENABLE_PROBES_UNIX" OFF)
cmake_dependent_option(OPENSCAP_PROBE_UNIX_FILEEXTENDEDATTRIBUTE "Unix fileextendedattribute probe" ON "ENABLE_PROBES_UNIX; HAVE_SYS_XATTR_H OR HAVE_ATTR_XATTR_H OR HAVE_SYS_EXTATTR_H" OFF)

=== src/CMakeLists.txt ===
add_subdirectory("common")
add_subdirectory("CPE")
add_subdirectory("CVE")
add_subdirectory("CVSS")
add_subdirectory("CVRF")
add_subdirectory("DS")
add_subdirectory("OVAL")
if(ENABLE_SCE)
	add_subdirectory("SCE")
endif()
add_subdirectory("source")
add_subdirectory("XCCDF")
add_subdirectory("XCCDF_POLICY")

set(OBJECTS_TO_LINK_AGAINST
	$<TARGET_OBJECTS:common_object>
	$<TARGET_OBJECTS:cpe_object>
	$<TARGET_OBJECTS:cve_object>
	$<TARGET_OBJECTS:cvrf_object>
	$<TARGET_OBJECTS:cvss_object>
	$<TARGET_OBJECTS:ds_object>
	$<TARGET_OBJECTS:oscapsource_object>
	$<TARGET_OBJECTS:oval_object>
	$<TARGET_OBJECTS:ovaladt_object>
	$<TARGET_OBJECTS:ovalcmp_object>
	$<TARGET_OBJECTS:ovalresults_object>
	$<TARGET_OBJECTS:rbt_object>
	$<TARGET_OBJECTS:xccdf_object>
	$<TARGET_OBJECTS:xccdfPolicy_object>
)
if (TARGET "compat_object")
	list(APPEND OBJECTS_TO_LINK_AGAINST $<TARGET_OBJECTS:compat_object>)
endif()
if (TARGET "yamlfilter_object")
	list(APPEND OBJECTS_TO_LINK_AGAINST $<TARGET_OBJECTS:yamlfilter_object>)
endif()
if (ENABLE_PROBES)
	list(APPEND OBJECTS_TO_LINK_AGAINST
		$<TARGET_OBJECTS:probe_object>
		$<TARGET_OBJECTS:seap_object>
	)
	if (ENABLE_PROBES_INDEPENDENT)
		list(APPEND OBJECTS_TO_LINK_AGAINST
			$<TARGET_OBJECTS:independent_probes_object>
		)
	endif()
	if (ENABLE_PROBES_UNIX)
		list(APPEND OBJECTS_TO_LINK_AGAINST
			$<TARGET_OBJECTS:unix_probes_object>
		)
		if (ENABLE_PROBES_LINUX)
			list(APPEND OBJECTS_TO_LINK_AGAINST
				$<TARGET_OBJECTS:linux_probes_object>
			)
		endif()
		if (ENABLE_PROBES_SOLARIS)
			list(APPEND OBJECTS_TO_LINK_AGAINST
				$<TARGET_OBJECTS:solaris_probes_object>
			)
		endif()
	endif()
	if (ENABLE_PROBES_WINDOWS)
		list(APPEND OBJECTS_TO_LINK_AGAINST
			$<TARGET_OBJECTS:windows_probes_object>
		)
	endif()
endif()
if (HAVE_MMAN_H AND (GCRYPT_FOUND OR NSS_FOUND))
	list(APPEND OBJECTS_TO_LINK_AGAINST
		$<TARGET_OBJECTS:crapi_object>
	)
endif()

add_library(openscap SHARED ${OBJECTS_TO_LINK_AGAINST})

# default symbol visibility is hidden
# exported symbols must be marked by OSCAP_API
set_target_properties(openscap PROPERTIES
	VERSION ${SONAME}
	SOVERSION ${SOVERSION}
	C_VISIBILITY_PRESET hidden
)

target_link_libraries(openscap ${LIBXML2_LIBRARIES} ${LIBXSLT_LIBRARIES} ${XMLSEC_LIBRARIES} ${OPENSSL_LIBRARIES} ${LIBXSLT_EXSLT_LIBRARIES} ${PCRE_LIBRARIES} ${PCRE2_LIBRARIES} ${CURL_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
if (BZIP2_FOUND)
	target_link_libraries(openscap ${BZIP2_LIBRARIES})
endif()
if(RPM_FOUND)
	target_link_libraries(openscap ${RPM_LIBRARIES})
endif()
if(WIN32)
	target_link_libraries(openscap wsock32 ws2_32 iphlpapi netapi32 wbemuuid)
endif()
if (GCRYPT_FOUND)
	target_link_libraries(openscap ${GCRYPT_LIBRARIES})
endif()
if (NSS_FOUND)
	target_link_libraries(openscap ${NSS_LIBRARIES})
endif()
if(OPENDBX_FOUND)
	target_link_libraries(openscap ${OPENDBX_LIBRARIES})
endif()
if(GCONF_FOUND)
	target_link_libraries(openscap ${GCONF_LIBRARIES})
endif()
if(SELINUX_FOUND)
	target_link_libraries(openscap ${SELINUX_LIBRARIES})
endif()
if(PROCPS_FOUND)
	target_link_libraries(openscap ${PROCPS_LIBRARIES})
endif()
if(BLKID_FOUND)
	target_link_libraries(openscap ${BLKID_LIBRARIES})
endif()
if(DBUS_FOUND)
	target_link_libraries(openscap ${DBUS_LIBRARIES})
endif()
if(APTPKG_FOUND)
	target_link_libraries(openscap ${APTPKG_LIBRARIES})
endif()
if(ACL_FOUND)
	target_link_libraries(openscap ${ACL_LIBRARY})
endif()
if(CAP_FOUND)
	target_link_libraries(openscap ${CAP_LIBRARIES})
endif()
if(LIBYAML_FOUND)
	target_link_libraries(openscap ${LIBYAML_LIBRARIES})
endif()

if(WIN32)
	set(OPENSCAP_INSTALL_DESTINATION ".")
else()
	set(OPENSCAP_INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

install(TARGETS openscap DESTINATION ${OPENSCAP_INSTALL_DESTINATION})

=== utils/CMakeLists.txt ===
install(PROGRAMS "oscap-run-sce-script"
	DESTINATION ${CMAKE_INSTALL_BINDIR}
)

if(ENABLE_OSCAP_UTIL)
	file(GLOB UTILS_SOURCES "*.c")
	if(HAVE_GETOPT_H)
		list(REMOVE_ITEM UTILS_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/getopt.c")
	endif()
	add_executable(oscap ${UTILS_SOURCES})
	target_link_libraries(oscap openscap)
	if(WIN32)
		if(NOT MINGW)
			find_path(GETOPT_INCLUDE_DIR getopt.h)
			include(SelectLibraryConfigurations)
			find_library(GETOPT_LIBRARY_RELEASE NAMES getopt)
			find_library(GETOPT_LIBRARY_DEBUG NAMES getopt PATH_SUFFIXES debug/lib)
			select_library_configurations(GETOPT)

			message("GETOPT_INCLUDE_DIR: ${GETOPT_INCLUDE_DIR}")
			message("GETOPT_LIBRARY: ${GETOPT_LIBRARY}")

			target_include_directories(oscap PRIVATE ${GETOPT_INCLUDE_DIR})
			target_link_libraries(oscap ${GETOPT_LIBRARY})
		endif()
		
		set(OSCAP_UTIL_DESTINATION ".")
		# Install the 'oscap' utility
		install(TARGETS "oscap"
			DESTINATION ${OSCAP_UTIL_DESTINATION}
		)
		# Install all recursively dependent DLLs for oscap.exe
		set(APPS "\${CMAKE_INSTALL_PREFIX}/oscap.exe") # the \ before $ is required by BundleUtilities
		set(VCPKG_DLL_DIR "${_VCPKG_INSTALLED_DIR}/${VCPKG_TARGET_TRIPLET}/bin")
		install(CODE "
			include(BundleUtilities)
			fixup_bundle(\"${APPS}\" \"\" \"${VCPKG_DLL_DIR}\")
		")
	else()
		set(OSCAP_UTIL_DESTINATION ${CMAKE_INSTALL_BINDIR})
		# Install the 'oscap' utility
		install(TARGETS "oscap"
			DESTINATION ${OSCAP_UTIL_DESTINATION}
		)
		# Install manual page
		install(FILES "oscap.8"
			DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
		)

		add_custom_target(oscap-chrootable-nocap
			COMMAND cp oscap oscap-chrootable
			COMMENT "Copying oscap binary to a buddy binary that awaits chroot blessing by setcap"
			DEPENDS oscap
		)
		add_custom_target(oscap-chrootable
			COMMAND setcap cap_sys_chroot+ep oscap-chrootable
			COMMENT "Generating chroot-capable oscap buddy"
			DEPENDS oscap-chrootable-nocap
		)

		if(WITH_SYSTEMD)
			if (ENABLE_OSCAP_REMEDIATE_SERVICE)
				install(PROGRAMS "oscap-remediate"
					DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}
				)
				install(PROGRAMS "oscap-remediate-offline"
					DESTINATION ${CMAKE_INSTALL_BINDIR}
				)
				install(FILES "oscap-remediate-offline.8"
					DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
				)
			endif()
		endif()
	endif()
endif()
if(ENABLE_OSCAP_UTIL_CHROOT)
	install(PROGRAMS "oscap-chroot"
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "oscap-chroot.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()
if(ENABLE_OSCAP_UTIL_DOCKER)
	configure_file("oscap-docker.in" "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/oscap-docker" @ONLY)
	file(
		COPY "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/oscap-docker"
		DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
		FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)

	if(NOT PYTHON_SITE_PACKAGES_INSTALL_DIR)
	execute_process(COMMAND
		${OSCAP_DOCKER_PYTHON} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(False, False, prefix='${CMAKE_INSTALL_PREFIX}'))"
		OUTPUT_VARIABLE PYTHON_SITE_PACKAGES_INSTALL_DIR
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
	endif()

	install(DIRECTORY oscap_docker_python
		DESTINATION ${PYTHON_SITE_PACKAGES_INSTALL_DIR}
	)
	install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/oscap-docker
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "oscap-docker.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()
if(ENABLE_OSCAP_UTIL_SSH)
	install(PROGRAMS "oscap-ssh"
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "oscap-ssh.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()
if(ENABLE_OSCAP_UTIL_AUTOTAILOR)
	install(PROGRAMS "autotailor"
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "autotailor.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()
if(ENABLE_OSCAP_UTIL_VM)
	install(PROGRAMS "oscap-vm"
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "oscap-vm.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()
if(ENABLE_OSCAP_UTIL_PODMAN)
	install(PROGRAMS "oscap-podman"
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "oscap-podman.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()
if(ENABLE_OSCAP_UTIL_AS_RPM)
	install(PROGRAMS "scap-as-rpm"
		DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
	install(FILES "scap-as-rpm.8"
		DESTINATION "${CMAKE_INSTALL_MANDIR}/man8"
	)
endif()

=== tests/API/CMakeLists.txt ===
add_subdirectory("CPE")
add_subdirectory("crypt")
add_subdirectory("CVE")
add_subdirectory("CVRF")
add_subdirectory("CVSS")
add_subdirectory("OVAL")
if (ENABLE_PROBES)
	add_subdirectory("probes")
	add_subdirectory("SEAP")
endif()
add_subdirectory("XCCDF")

=== tests/DS/ds_sds_index/CMakeLists.txt ===
add_oscap_test_executable(test_ds_sds_index "test_ds_sds_index.c")
add_oscap_test_executable(test_ds_sds_index_multiple "test_ds_sds_index_multiple.c")

add_oscap_test("all.sh")

=== tests/DS/schematron/CMakeLists.txt ===
add_oscap_test("schematron.sh")

=== tests/probes/isainfo/CMakeLists.txt ===
if(ENABLE_PROBES_SOLARIS)
	add_oscap_test("test_probes_isainfo.sh")
endif()

=== tests/probes/yamlfilecontent/CMakeLists.txt ===
if(ENABLE_PROBES_INDEPENDENT)
	add_oscap_test("test_probes_yamlfilecontent_key.sh")
	add_oscap_test("test_probes_yamlfilecontent_array.sh")
	add_oscap_test("test_probes_yamlfilecontent_offline_mode.sh")
	add_oscap_test("test_probes_yamlfilecontent_types.sh")
	add_oscap_test("test_probes_yamlfilecontent_content.sh")
endif()

=== tests/API/XCCDF/guide/CMakeLists.txt ===
add_oscap_test("benchmark.sh")
add_oscap_test("guide.sh")
add_oscap_test("profile.sh")

=== tests/API/XCCDF/parser/CMakeLists.txt ===
add_oscap_test_executable(test_api_xccdf "test_api_xccdf.c")
add_oscap_test("test_api_xccdf.sh")
add_oscap_test("test_extensions.sh")

=== tests/API/XCCDF/unittests/CMakeLists.txt ===
add_oscap_test_executable(test_oscap_common
	"test_oscap_common.c"
	${CMAKE_SOURCE_DIR}/src/common/util.c
	${CMAKE_SOURCE_DIR}/src/common/list.c
	${CMAKE_SOURCE_DIR}/src/common/error.c
	${CMAKE_SOURCE_DIR}/src/common/err_queue.c
	${CMAKE_SOURCE_DIR}/src/common/oscap_pcre.c
)

add_oscap_test_executable(test_xccdf_overrides
	"test_xccdf_overrides.c"
)

add_oscap_test_executable(test_xccdf_shall_pass
	test_xccdf_shall_pass.c
	unit_helper.c
)
target_link_libraries(test_xccdf_shall_pass openscap ${LIBXML2_LIBRARIES} ${LIBXSLT_LIBRARIES} ${LIBXSLT_EXSLT_LIBRARIES} ${PCRE_LIBRARIES} ${CURL_LIBRARIES} ${RPM_LIBRARIES})

if(PYTHONINTERP_FOUND)
	add_oscap_test("all_python.sh")
endif()

add_oscap_test("test_ansible_yaml_block_scalar.sh")
add_oscap_test("test_xccdf_shall_pass1.sh")
add_oscap_test("test_xccdf_shall_pass2.sh")
add_oscap_test("test_xccdf_shall_pass3.sh")
add_oscap_test("test_oscap_common.sh")
add_oscap_test("test_xccdf_overrides.sh")
add_oscap_test("test_xccdf_role_unscored.sh")
add_oscap_test("test_remediate_unresolved.sh")
add_oscap_test("test_empty_variable.sh")
add_oscap_test("test_fix_instance.sh")
add_oscap_test("test_xccdf_xml_escaping_value.sh")
add_oscap_test("test_xccdf_check_negate.sh")
add_oscap_test("test_xccdf_check_multi_check.sh")
add_oscap_test("test_xccdf_check_multi_check2.sh")
add_oscap_test("test_xccdf_check_multi_check_zero_definitions.sh")
add_oscap_test("test_xccdf_check_ocil.sh")
add_oscap_test("test_xccdf_check_content_ref_without_name_attr.sh")
add_oscap_test("test_xccdf_check_without_content_refs.sh")
add_oscap_test("test_xccdf_refine_rule.sh")
add_oscap_test("test_xccdf_refine_rule_refine.sh")
add_oscap_test("test_xccdf_fix_attr_export.sh")
add_oscap_test("test_xccdf_complex_check_and_notchecked.sh")
add_oscap_test("test_xccdf_check_processing_complex_priority.sh")
add_oscap_test("test_xccdf_check_processing_selector_bad.sh")
add_oscap_test("test_xccdf_check_processing_selector_empty.sh")
add_oscap_test("test_xccdf_check_processing_invalid_content_refs.sh")
add_oscap_test("test_xccdf_notchecked_has_check.sh")
add_oscap_test("test_xccdf_role_unchecked.sh")
add_oscap_test("test_xccdf_oval_absolute_path.sh")
add_oscap_test("test_xccdf_oval_relative_path.sh")
add_oscap_test("test_xccdf_selectors_cluster1.sh")
add_oscap_test("test_xccdf_selectors_cluster2.sh")
add_oscap_test("test_xccdf_selectors_cluster3.sh")
add_oscap_test("test_deriving_xccdf_result_from_oval.sh")
add_oscap_test("test_deriving_xccdf_result_from_oval2.sh")
add_oscap_test("test_oval_without_definition.sh")
add_oscap_test("test_deriving_xccdf_result_from_oval_multicheck.sh")
add_oscap_test("test_multiple_oval_files_with_same_basename.sh")
add_oscap_test("test_xccdf_check_unsupported_check_system.sh")
add_oscap_test("test_xccdf_multiple_testresults.sh")
add_oscap_test("test_default_selector.sh")
add_oscap_test("test_inherit_selector.sh")
add_oscap_test("test_xccdf_refine_value_bad.sh")
add_oscap_test("test_xccdf_resolve.sh")
add_oscap_test("test_xccdf_resolve_profile_platform.sh")
add_oscap_test("test_xccdf_results_arf_no_oval.sh")
add_oscap_test("test_xccdf_results_arf_asset.sh")
add_oscap_test("test_xccdf_sub_title.sh")
add_oscap_test("test_xccdf_test_system.sh")
add_oscap_test("test_profile_selection_by_suffix.sh")
add_oscap_test("test_unfinished.sh")
add_oscap_test("test_xccdf_transformation.sh")
add_oscap_test("test_single_rule.sh")
add_oscap_test("test_single_rule_stigw.sh")
add_oscap_test("test_remediation_simple.sh")
add_oscap_test("test_remediation_offline.sh")
add_oscap_test("test_remediation_metadata.sh")
add_oscap_test("test_remediation_blueprint.sh")
add_oscap_test("test_remediation_bad_fix.sh")
add_oscap_test("test_remediation_subs_plain_text.sh")
add_oscap_test("test_remediation_subs_plain_text_empty.sh")
add_oscap_test("test_remediation_subs_value_refine_value.sh")
add_oscap_test("test_remediation_subs_value_take_first.sh")
add_oscap_test("test_remediation_subs_value_without_selector.sh")
add_oscap_test("test_remediation_subs_value_title.sh")
add_oscap_test("test_remediation_amp_escaping.sh")
add_oscap_test("test_remediation_xml_comments.sh")
add_oscap_test("test_remediation_cdata.sh")
add_oscap_test("test_remediation_subs_unresolved.sh")
add_oscap_test("test_remediation_fix_without_system.sh")
add_oscap_test("test_remediation_invalid_characters.sh")
add_oscap_test("test_remediate_simple.sh")
add_oscap_test("test_remediate_perl.sh")
add_oscap_test("test_report_check_with_empty_selector.sh")
add_oscap_test("test_report_without_xsl_fails_gracefully.sh")
add_oscap_test("test_report_without_oval_poses_no_errors.sh")
add_oscap_test("test_report_anaconda_fixes.sh")
add_oscap_test("test_report_anaconda_fixes_ds.sh")
add_oscap_test("test_fix_filtering.sh")
add_oscap_test("test_fix_script_header.sh")
add_oscap_test("test_fix_arf.sh")
add_oscap_test("test_fix_resultid_by_suffix.sh")
add_oscap_test("test_generate_fix_ansible_vars.sh")
add_oscap_test("test_xccdf_requires_conflicts.sh")
add_oscap_test("test_results_hostname.sh")
add_oscap_test("test_skip_rule.sh")
add_oscap_test("test_no_newline_between_select_elements.sh")
add_oscap_test("test_single_line_tailoring.sh")

=== src/OVAL/probes/unix/linux/CMakeLists.txt ===
if(OPENSCAP_PROBE_LINUX_DPKGINFO)
	list(APPEND LINUX_PROBES_SOURCES
		"dpkginfo-helper.cxx"
		"dpkginfo-helper.h"
		"dpkginfo_probe.c"
		"dpkginfo_probe.h"
	)
	list(APPEND LINUX_PROBES_INCLUDE_DIRECTORIES
		${APTPKG_INCLUDE_DIR}
	)
endif()

if(OPENSCAP_PROBE_LINUX_IFLISTENERS)
	list(APPEND LINUX_PROBES_SOURCES
		"iflisteners_probe.c"
		"iflisteners_probe.h"
		"iflisteners-proto.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_INETLISTENINGSERVERS)
	list(APPEND LINUX_PROBES_SOURCES
		"inetlisteningservers_probe.c"
		"inetlisteningservers_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_PARTITION)
	list(APPEND LINUX_PROBES_SOURCES
		"partition_probe.c"
		"partition_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_RPMINFO OR OPENSCAP_PROBE_LINUX_RPMVERIFY OR OPENSCAP_PROBE_LINUX_RPMVERIFYFILE OR OPENSCAP_PROBE_LINUX_RPMVERIFYPACKAGE)
	list(APPEND LINUX_PROBES_SOURCES
		"probe-chroot.c"
		"probe-chroot.h"
		"rpm-helper.c"
		"rpm-helper.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_RPMINFO)
	list(APPEND LINUX_PROBES_SOURCES
		"rpminfo_probe.c"
		"rpminfo_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_RPMVERIFY)
	list(APPEND LINUX_PROBES_SOURCES
		"rpmverify_probe.c"
		"rpmverify_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_RPMVERIFYFILE)
	list(APPEND LINUX_PROBES_SOURCES
		"rpmverifyfile_probe.c"
		"rpmverifyfile_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_RPMVERIFYPACKAGE)
	list(APPEND LINUX_PROBES_SOURCES
		"rpmverifypackage_probe.c"
		"rpmverifypackage_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_SELINUXBOOLEAN OR OPENSCAP_PROBE_LINUX_SELINUXSECURITYCONTEXT)
	list(APPEND LINUX_PROBES_INCLUDE_DIRECTORIES
		${SELINUX_INCLUDE_DIR}
	)
endif()

if(OPENSCAP_PROBE_LINUX_SELINUXBOOLEAN)
	list(APPEND LINUX_PROBES_SOURCES
		"selinuxboolean_probe.c"
		"selinuxboolean_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_SELINUXSECURITYCONTEXT)
	list(APPEND LINUX_PROBES_SOURCES
		"selinuxsecuritycontext_probe.c"
		"selinuxsecuritycontext_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_SYSTEMDUNITDEPENDENCY OR OPENSCAP_PROBE_LINUX_SYSTEMDUNITPROPERTY)
	list(APPEND LINUX_PROBES_SOURCES
		"systemdshared.h"
		"oval_dbus.c"
		"oval_dbus.h"
	)
	list(APPEND LINUX_PROBES_INCLUDE_DIRECTORIES
		${DBUS_INCLUDE_DIRS}
	)
endif()

if(OPENSCAP_PROBE_LINUX_SYSTEMDUNITDEPENDENCY)
	list(APPEND LINUX_PROBES_SOURCES
		"systemdunitdependency_probe.c"
		"systemdunitdependency_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_SYSTEMDUNITPROPERTY)
	list(APPEND LINUX_PROBES_SOURCES
		"systemdunitproperty_probe.c"
		"systemdunitproperty_probe.h"
	)
endif()

if(OPENSCAP_PROBE_LINUX_FWUPDSECURITYATTR)
	list(APPEND LINUX_PROBES_SOURCES
		"oval_dbus.c"
		"oval_dbus.h"
	)
	list(APPEND LINUX_PROBES_SOURCES
		"fwupdsecattr_probe.c"
		"fwupdsecattr_probe.h"
	)
	list(APPEND LINUX_PROBES_INCLUDE_DIRECTORIES
		${DBUS_INCLUDE_DIRS}
	)
endif()


add_library(linux_probes_object OBJECT ${LINUX_PROBES_SOURCES})
set_oscap_generic_properties(linux_probes_object)
target_include_directories(linux_probes_object PRIVATE ${LINUX_PROBES_INCLUDE_DIRECTORIES})

=== debian/changelog ===
openscap (1.3.9+dfsg-1.1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:27:26 +0000

openscap (1.3.9+dfsg-1.1ubuntu1) noble; urgency=medium

  * Fix FTBFS with Python 3.12

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 21 Mar 2024 18:06:22 +0100

openscap (1.3.9+dfsg-1.1build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@debian.org>  Sat, 02 Mar 2024 21:20:17 +0100

openscap (1.3.9+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063101

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 12:52:30 +0000

openscap (1.3.9+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Change build-dependency to PCRE2. Closes: #1000008
  * Update symbols for openscap_sce

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sat, 09 Sep 2023 12:12:07 +0200

=== debian/control ===
Source: openscap
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Håvard F. Aasen <havard.f.aasen@pfft.no>
Build-Depends: dpkg-dev (>= 1.22.5), cmake,
               debhelper-compat (= 13),
               dh-python,
               libacl1-dev,
               libapt-pkg-dev,
               libattr1-dev,
               libblkid-dev,
               libbz2-dev,
               libcap-dev [linux-any],
               libcurl4-openssl-dev | libcurl4-gnutls-dev,
               libdbus-1-dev,
               libgcrypt-dev,
               libglib2.0-dev,
               libldap2-dev,
               libopendbx1-dev,
               libpcre2-dev,
               libperl-dev,
               libpopt-dev,
               libpython3-all-dev,
               librpm-dev,
               libselinux1-dev [linux-any],
               libxml-parser-perl <!nocheck>,
               libxml-xpath-perl <!nocheck>,
               libxml2-dev,
               libxmlsec1-dev,
               libxslt1-dev,
               libyaml-dev,
               pkg-config,
               python3-all-dev:native,
               swig,
Build-Depends-Indep: asciidoc,
                     doxygen,
                     graphviz,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.open-scap.org/
Vcs-Browser: https://salsa.debian.org/debian/openscap
Vcs-Git: https://salsa.debian.org/debian/openscap.git

Package: libopenscap-dev
Section: libdevel
Architecture: linux-any
Depends: libopenscap25t64 (= ${binary:Version}),
         ${misc:Depends},
Suggests: openscap-doc,
Description: libraries enabling integration of the SCAP line of standards - Development files
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains the development files for OpenSCAP.

Package: libopenscap25t64
Provides: ${t64:Provides}
Breaks: libopenscap25 (<< ${source:Version})
Section: libs
Architecture: linux-any
Conflicts: libopenscap8,
Replaces: libopenscap25, libopenscap8,
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: libraries enabling integration of the SCAP line of standards
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains libraries for OpenSCAP.

Package: python3-openscap
Section: python
Architecture: linux-any
Depends: libopenscap25t64 (= ${binary:Version}),
         python3-docker,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Suggests: openscap-doc,
Provides: ${python3:Provides},
Description: libraries enabling integration of the SCAP line of standards - Python 3 bindings
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains the Python bindings for OpenSCAP.

Package: libopenscap-perl
Section: perl
Architecture: linux-any
Depends: libopenscap25t64 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends},
Suggests: openscap-doc,
Description: libraries enabling integration of the SCAP line of standards - Perl bindings
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains the Perl bindings for OpenSCAP.

Package: openscap-scanner
Architecture: linux-any
Depends: libopenscap25t64 (= ${binary:Version}),
         openscap-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: openscap-doc,
Description: OpenScap Scanner Tool (oscap)
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains oscap command-line tool, configuration and
 vulnerability scanner. It can use for compliance checking with SCAP contents.

Package: openscap-utils
Architecture: linux-any
Depends: openscap-scanner (= ${binary:Version}),
         python3-openscap (= ${binary:Version}),
         rpm,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Suggests: openscap-doc,
Description: libraries enabling integration of the SCAP line of standards - Utility programs
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains command line utilities.

Package: openscap-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Breaks: libopenscap8 (<< 1.3.5),
Replaces: libopenscap8 (<< 1.3.5),
Description: OpenSCAP schema files
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains schema files.

Package: openscap-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: libraries enabling integration of the SCAP line of standards - Documentation
 OpenSCAP is a set of open source libraries providing an easier path
 for integration of the SCAP line of standards. SCAP is a line of
 standards managed by NIST with the goal of providing a standard language
 for the expression of Computer Network Defense related information.
 .
 The intended scope of this project is to implement working interface
 wrappers for parsing and querying SCAP content including:
  * Common Vulnerabilities and Exposures (CVE)
  * Common Configuration Enumeration (CCE)
  * Common Platform Enumeration (CPE)
  * Common Vulnerability Scoring System (CVSS)
  * Extensible Configuration Checklist Description Format (XCCDF)
  * Open Vulnerability and Assessment Language (OVAL)
 .
 This package contains documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

PYVERS=$(shell py3versions --supported --version)
CMAKE_OPTS = \
	     -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	     -DENABLE_DOCS=ON \
	     -DENABLE_OSCAP_REMEDIATE_SERVICE=OFF \
	     -DENABLE_PERL=ON \
	     -DOPENSCAP_PROBE_UNIX_GCONF=OFF \
	     -DGCONF_LIBRARY= \
	     -DPYTHON_EXECUTABLE=/usr/bin/python$$V \
	     -DWITH_PCRE2=ON

override_dh_auto_clean:
	for V in $(PYVERS); do \
		dh_auto_clean --builddir=build-py$$V ; \
	done

override_dh_auto_configure:
	for V in $(PYVERS); do \
		dh_auto_configure --builddir=build-py$$V -- \
			$(CMAKE_OPTS) ; \
	done

override_dh_auto_build:
	for V in $(PYVERS); do \
		dh_auto_build --builddir=build-py$$V ; \
	done

override_dh_auto_install:
	# Move Python files to separate folders so they don't overwrite
	# each other at install time.
	for V in $(PYVERS); do \
		dh_auto_install --builddir=build-py$$V ; \
		mv ${CURDIR}/debian/tmp/usr/lib/python3 ${CURDIR}/debian/tmp/usr/lib/python$$V ; \
		chmod 0644 ${CURDIR}/debian/tmp/usr/lib/python$$V/dist-packages/openscap_py.py ; \
		chmod 0644 ${CURDIR}/debian/tmp/usr/lib/python$$V/dist-packages/openscap_api.py ; \
	done

	find debian/tmp -name "*.la" -delete
	$(RM) $(CURDIR)/debian/tmp/usr/share/doc/openscap/html/*.md5 \
	      $(CURDIR)/debian/tmp/usr/share/doc/openscap/html/*.map

override_dh_python3:
	dh_python3 -popenscap-utils -ppython3-openscap --shebang=/usr/bin/python3

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# Skip tests when building for 'all'.
override_dh_auto_test-indep:

override_dh_auto_test-arch:
	for V in $(PYVERS); do \
		dh_auto_test --no-parallel --builddir=build-py$$V ; \
	done

%:
	dh $@ --with python3

## openscap 1.3.10+dfsg

=== debian/changelog ===
openscap (1.3.10+dfsg-3) unstable; urgency=medium

  * Update Standards-Version to 4.7.0, no changes needed.
  * Add patch to skip tests that require internet Closes: #1071641

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Fri, 24 May 2024 07:42:17 +0200

openscap (1.3.10+dfsg-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix cross misbuild: Closes: #1070328
    - Build-Depends: perl-xs-dev for building a perl extension.
    - Supply a cross PERL5LIB.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sat, 04 May 2024 22:27:43 +0200

openscap (1.3.10+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Patches:
    - Drop patches included upstream, switch-perl-install-destinations.patch
      and fix-remowal-of-imp-module-in-python312.patch.
    - Update run-a-minor-testsuite.patch, run more tests.
  * Add python3-pytest as BD, used for testing.
  * Remove libapt-pkg-dev as BD, uses dpkg directly.
  * Update symbols file.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Fri, 05 Apr 2024 07:40:35 +0200

openscap (1.3.9+dfsg-2) unstable; urgency=medium

  * Update BD to depend on pkgconf.
  * Add upstream patch to fix Python 3.12 failure.
  * Minor cleanup after time_t transition.
  * Update copyright year on myself.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sun, 03 Mar 2024 09:11:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: openscap
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Håvard F. Aasen <havard.f.aasen@pfft.no>
-Build-Depends: dpkg-dev (>= 1.22.5), cmake,
+Maintainer: Håvard F. Aasen <havard.f.aasen@pfft.no>
+Build-Depends: cmake,
                debhelper-compat (= 13),
                dh-python,
+               dpkg-dev (>= 1.22.5),
                libacl1-dev,
-               libapt-pkg-dev,
                libattr1-dev,
                libblkid-dev,
                libbz2-dev,
@@ -19,7 +18,6 @@
                libldap2-dev,
                libopendbx1-dev,
                libpcre2-dev,
-               libperl-dev,
                libpopt-dev,
                libpython3-all-dev,
                librpm-dev,
@@ -30,13 +28,15 @@
                libxmlsec1-dev,
                libxslt1-dev,
                libyaml-dev,
-               pkg-config,
+               perl-xs-dev,
+               pkgconf,
                python3-all-dev:native,
+               python3-pytest <!nocheck>,
                swig,
 Build-Depends-Indep: asciidoc,
                      doxygen,
                      graphviz,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://www.open-scap.org/
 Vcs-Browser: https://salsa.debian.org/debian/openscap
@@ -66,12 +66,13 @@
  This package contains the development files for OpenSCAP.
 
 Package: libopenscap25t64
-Provides: ${t64:Provides}
-Breaks: libopenscap25 (<< ${source:Version})
+Provides: ${t64:Provides},
+Breaks: libopenscap25 (<< ${source:Version}),
 Section: libs
 Architecture: linux-any
 Conflicts: libopenscap8,
-Replaces: libopenscap25, libopenscap8,
+Replaces: libopenscap25,
+          libopenscap8,
 Pre-Depends: ${misc:Pre-Depends},
 Depends: ${misc:Depends},
          ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,14 @@
 #export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
+
+include /usr/share/dpkg/architecture.mk
+
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+PERLVER := $(shell perl -MConfig -e 'print $$Config{version}')
+PERL5LIB := /usr/lib/$(DEB_HOST_MULTIARCH)/perl/cross-config-$(PERLVER)$(if $(PERL5LIB),:$(PERL5LIB))
+export PERL5LIB
+endif
 
 PYVERS=$(shell py3versions --supported --version)
 CMAKE_OPTS = \
